diff --git a/block/qcow2-snapshot.c b/block/qcow2-snapshot.c
index 92b87f8..7f24486 100644
--- a/block/qcow2-snapshot.c
+++ b/block/qcow2-snapshot.c
@@ -26,6 +26,8 @@
 #include "block/block_int.h"
 #include "block/qcow2.h"
 
+/* #define QCOW2_SNAPSHOT_PRINT_ERROR_PATH */
+
 typedef struct QEMU_PACKED QCowSnapshotHeader {
     /* header is 8 byte aligned */
     uint64_t l1_table_offset;
@@ -182,10 +184,16 @@ static int qcow2_write_snapshots(BlockDriverState *bs)
     snapshots_offset = qcow2_alloc_clusters(bs, snapshots_size);
     offset = snapshots_offset;
     if (offset < 0) {
+#ifdef QCOW2_SNAPSHOT_PRINT_ERROR_PATH
+        printf("qcow2: Failed in allocation of snapshot list\n");
+#endif
         return offset;
     }
     ret = bdrv_flush(bs);
     if (ret < 0) {
+#ifdef QCOW2_SNAPSHOT_PRINT_ERROR_PATH
+        printf("qcow2: Failed in flush after snapshot list allocation\n");
+#endif
         goto fail;
     }
 
@@ -194,6 +202,9 @@ static int qcow2_write_snapshots(BlockDriverState *bs)
     ret = qcow2_pre_write_overlap_check(bs, QCOW2_OL_DEFAULT, offset,
                                         s->snapshots_size);
     if (ret < 0) {
+#ifdef QCOW2_SNAPSHOT_PRINT_ERROR_PATH
+        printf("qcow2: Failed in overlap check before update snapshot list\n");
+#endif
         goto fail;
     }
 
@@ -227,24 +238,36 @@ static int qcow2_write_snapshots(BlockDriverState *bs)
 
         ret = bdrv_pwrite(bs->file, offset, &h, sizeof(h));
         if (ret < 0) {
+#ifdef QCOW2_SNAPSHOT_PRINT_ERROR_PATH
+            printf("qcow2: Failed in update of snapshot header\n");
+#endif
             goto fail;
         }
         offset += sizeof(h);
 
         ret = bdrv_pwrite(bs->file, offset, &extra, sizeof(extra));
         if (ret < 0) {
+#ifdef QCOW2_SNAPSHOT_PRINT_ERROR_PATH
+            printf("qcow2: Failed in update of extra snapshot info\n");
+#endif
             goto fail;
         }
         offset += sizeof(extra);
 
         ret = bdrv_pwrite(bs->file, offset, sn->id_str, id_str_size);
         if (ret < 0) {
+#ifdef QCOW2_SNAPSHOT_PRINT_ERROR_PATH
+            printf("qcow2: Failed in update of snapshot id\n");
+#endif
             goto fail;
         }
         offset += id_str_size;
 
         ret = bdrv_pwrite(bs->file, offset, sn->name, name_size);
         if (ret < 0) {
+#ifdef QCOW2_SNAPSHOT_PRINT_ERROR_PATH
+            printf("qcow2: Failed in update of snapshot name\n");
+#endif
             goto fail;
         }
         offset += name_size;
@@ -256,6 +279,9 @@ static int qcow2_write_snapshots(BlockDriverState *bs)
      */
     ret = bdrv_flush(bs);
     if (ret < 0) {
+#ifdef QCOW2_SNAPSHOT_PRINT_ERROR_PATH
+        printf("qcow2: Failed in flush after update snapshot list\n");
+#endif
         goto fail;
     }
 
@@ -269,6 +295,9 @@ static int qcow2_write_snapshots(BlockDriverState *bs)
     ret = bdrv_pwrite_sync(bs->file, offsetof(QCowHeader, nb_snapshots),
                            &header_data, sizeof(header_data));
     if (ret < 0) {
+#ifdef QCOW2_SNAPSHOT_PRINT_ERROR_PATH
+        printf("qcow2: Failed in update qcow2 header in snapshot creation\n");
+#endif
         goto fail;
     }
 
@@ -366,6 +395,9 @@ int qcow2_snapshot_create(BlockDriverState *bs, QEMUSnapshotInfo *sn_info)
     l1_table_offset = qcow2_alloc_clusters(bs, s->l1_size * sizeof(uint64_t));
     if (l1_table_offset < 0) {
         ret = l1_table_offset;
+#ifdef QCOW2_SNAPSHOT_PRINT_ERROR_PATH
+        printf("qcow2: Failed in allocation of L1 table for snapshot\n");
+#endif
         goto fail;
     }
 
@@ -381,12 +413,20 @@ int qcow2_snapshot_create(BlockDriverState *bs, QEMUSnapshotInfo *sn_info)
     ret = qcow2_pre_write_overlap_check(bs, QCOW2_OL_DEFAULT,
             sn->l1_table_offset, s->l1_size * sizeof(uint64_t));
     if (ret < 0) {
+#ifdef QCOW2_SNAPSHOT_PRINT_ERROR_PATH
+        printf("qcow2: Failed in overlap check before update L1 table for "
+               "snapshot\n");
+#endif
         goto dealloc_cluster;
     }
 
+    BLKDBG_EVENT(bs->file, BLKDBG_SNAPSHOT_L1_UPDATE);
     ret = bdrv_pwrite(bs->file, sn->l1_table_offset, l1_table,
                       s->l1_size * sizeof(uint64_t));
     if (ret < 0) {
+#ifdef QCOW2_SNAPSHOT_PRINT_ERROR_PATH
+        printf("qcow2: Failed in update of L1 table for snapshot\n");
+#endif
         goto dealloc_cluster;
     }
 
@@ -400,6 +440,9 @@ int qcow2_snapshot_create(BlockDriverState *bs, QEMUSnapshotInfo *sn_info)
      */
     ret = qcow2_update_snapshot_refcount(bs, s->l1_table_offset, s->l1_size, 1);
     if (ret < 0) {
+#ifdef QCOW2_SNAPSHOT_PRINT_ERROR_PATH
+        printf("qcow2: Failed in update refcount for snapshot\n");
+#endif
         goto dealloc_cluster;
     }
 
@@ -419,6 +462,9 @@ int qcow2_snapshot_create(BlockDriverState *bs, QEMUSnapshotInfo *sn_info)
         g_free(s->snapshots);
         s->snapshots = old_snapshot_list;
         s->nb_snapshots = old_snapshot_num;
+#ifdef QCOW2_SNAPSHOT_PRINT_ERROR_PATH
+        printf("qcow2: Failed in update of snapshot list and header\n");
+#endif
         goto restore_refcount;
     }
 